class SuggestKeywords

	KEYWORDS = [
		['acceptance', @group4, /accept\w{0,4}|regret\w{0,4}/i],
		['addiction', @group1, /(alcoholism|alcoholic)|drinks?\s(every|all)\s(day|night|afternoon)|\burge\b|addict\w{0,3}/i, @group1],
		['aging', @group1, /accept\s(aging|(my|his|her)\s(new\s)?age)|get\w{0,4}\sold|turning\s\d\d\b/i],
		['alienation',@group3, /alienation/i],
		['amnesia', @group1, /amnesia|los\w{1,3}\s(my|her|his|of)\smemor\w{1,3}|memory\sloss/i],
		['anxiety', @group1, /anxi\w{3}|overthink\w{0,3}|panic(\s|-)attacks?/i],
		['apathy', @group3, /\bapath\w{1,5}|love\sme\sanymore|no\sfeelings/i],
		['approval', @group2, /accept(ing)?|(they|she|he)\s(will|can)\slike\sme|approval|bless\w{0,3}/i],
		['assault', @group3, /beat\w{0,3}|assault\w{0,3}|slam\w{0,3}|kick\w{0,3}|punch\w{0,3}|chok\w{0,3}/i],
		['assertion', @group2, /(be\s)?assert\w{0,3}|that\si\s(don't|do\snot)\swan(t|na)|how\sto\s(say|speak|tell|comunicate|approach)/i],
		['attraction', @group2, /(talk\w{0,3}\s(with|to)\s|approach\w{0,3}\s)(a\s)?(girl|boy|(wo)?man|chick)|ask\w{0,3}\s(me|her|him)\sout|ha(s|ve)\sa\scrush|flirt\w{0,3}|attract\w{0,3}/i],
		['blackmail', @group3, /threat\w{0,6}|(forc\w{1,3}|\bmak\w{1,3})\sme|black(\s|-)mail\w{0,3}/i],
		['breakup', @group2, /\bdump\w{0,3}\s(me|her|him)|(break\w{0,3}\-?|broke)\s?up/i],
		['business', @group5, /^(?!mind)(my|our|his|her|their)\s(business|company|startup)/i],
		['career', @group5, /career|aptitude|directions?|major\w{0,3}|course/i],
		['cheating', @group3, /cheat\w{0,3}|unfaithful|secret\w{0,2}\smessag\w{1,3}|messages\sin\ssecret|sexting|adultery/i],
		['children', @group2, /children|\bson\b|daughter|bab(y|ies)/i],
		['college', @group5, /college|university|student\sloans?|(my|get\sa)\smajor\w{0,3}(?!\scrush|\sdebt)|sophomore|drop\w{0,3}\sout|freshmen|academic\sadvisers?|professor/i],
		['conflict', @group3, /\bargu\w{1,4}|fight\s{0,3}|conflict\w{0,3}|friction|disagreement/i],
		['dating', @group2, /\bdat\w{1,3}|dating|older\sthan\s(me|i)|go\w{0,3}\sout\swith|out\sof\smy\sleague/i],
		['depression', @group4, /depress\w{2,3}|do(\snot|n't)\sfeel\spassionate|(i\s(am\s(worthless|garbage))|(wish\si\swas\sdead)|(might\saswell\sbe\sdead)|(look\w{0,3}\s(un)?happy)|(feel\sexhaust\w{2,3})|(suck\sat\severything))|(motivation|reason)\sto\s(keep)?\s?liv\w{1,3}|joy\sanymore|los\w{1,3}\smotivation|no\sresilience|not\seating|have\sno\sfriends|liv\w{1,3}\slike\sthis|lost\sin\slife|end\s(my|his|her)\slife|(motivation|reason)\sto\sget\sout\sof\sbed|i\s(just\s)?hate\smyself/i],
		['disappearance', @group3, /disappear\w{0,5}|(gone|is)\smissing|find\s(him|her)|nowhere\sto\sbe\sfound/i],
		['dismissal', @group5, /fire(d|\sme)|resign\w{0,5}|dismiss\w{0,3}|demission|expel\w{0,4}/i],
		['drop out', @group5, /drop\w{0,4}\sout|quit(ting)?\s(college|school)|giv(e|ing)\sup\son\s(my\scourse|college)/i],
		['drugs', @group1, /drugs?|alcohol|marijuana|\bpot\b|weed\b|hashish|cannabis|heroin|opium|cocaine|amphetamine|\bmeth(amphetamine)?|ecstasy|mdma|lsd|acid|steroids?/i],
		['elder abuse', @group3, /a^/],
		['estranged', @group2, /estranged?|no\slonger\s(likes?|loves?)\sme|(likes?|loves?)\sme\sanymore/i],
		['eviction', @group3, /evict\w{0,3}|kicked(-|\s)out|expulsion|expel\w{0,3}/i],
		['exercise', @group1, /work\w{0,3}-?out|exercis\w{1,3}|fitness/i],
		['financial abuse', @group3, /abus\w{1,3}|leech\w{0,3}|parasit\w{1,3}|rip\w{0,3}-off|exploit\w{0,6}/i],
		['fixation', @group2, /fixat\w{2,3}|obsess\w{2,3}|cling\w{1,3}|attached|\bsmother\w{0,3}/i],
		['focus', @group5, /(can't|los\w{1,3})\sfocus|concentrat\w{1,3}|attention/i],
		['ghosting', @group2, /ghosting|ignoring\sme|no(t)?\s(respon\w{0,4}|answer\w{0,3})|\bavoid(ing)?|(won't|didn't|not)\sreply\w{0,3}|stopped\s(talking|speaking)/i],
		['grades',@group5,  /grades?|\bGPA\b|fail\w{0,3}\sclass/i],
		['grief', @group4, /(deal\w{0,3}|handl\w{1,3}\s|process\w{0,3}\s)?(with\s)?(the\s)?(loss|death)(\sof\smy)|(mo(ther|m)|dad|(girl|boy)?friend|father|he|her)\s((just\s)?died|is\sdead)|lost\s(his|her|my|our)\s(mo(m|ther)|dad|father|brother|sister|grand(pa|ma|mother|father)|uncle|aunt|pet|dog|cat|(girl|boy)?friend)|is\sdying|pass\w{0,3}\saway|grie(f|ving)/i],
		['harassment', @group3, /(get\w{0,3}|got)?\s?(physical\w{1,2}|emocional\w{1,2})?\s?(abus\w{1,3}|threat\w{0,6}|accus\w{1,4}|bull(y\w{0,3}|ied)|harass\w{0,3})|knows\smy\sadress|forc\w{1,3}|uncomfortabl(e|y)|scar(ed|y)|curs\w{1,3}/i],
		['homeschooling', @group5, /homeschool\w{0,3}/i],
		['hygiene', @group1, /odour|smells?|stinks?|breath\b/i],
		['illegal', @group3, /illegal|\bcrimes?\b|agaisnt\sthe\slaw/i],
		['illness', @group1, /\bill\w{0,4}\b|vac(cines?|cination|cinated|\b)|diseases?|tumor|cancer|chemio\w{0,7}|constantly\ssick|(heart|kidneys?|liver|lungs?)\sproblem|\bill\w{0,4}|skin\sspots?|\bitchy?\b|\b(head)?ach(e|ing)|fever/i],
		['injury', @group1, /injur\w{1,3}|bleed\w{0,3}|wound\w{0,2}|bruises?|\bcut(ting)?\b|spine|\bnose\b|elbow|shoulder|wrist|knee/i],
		['inheritance', @group3, /inheritance|heritage|bequest|birthright/i],
		['insalubrity', @group5, /chemicals?|radiation|radioactive|hazard\w{0,3}|safety|carcinogenic|toxic|syringes?|fumes|smoke/i],
		['insurance', @group3, /insurance|\bcover\w{0,3}|protection|security/i],
		['intoxication', @group1, /intoxicat\w{2,3}|poison\w{0,3}|nausea|vomit\w{0,3}|throw\w{0,3}\sup|diarrhea/i],
		['jail', @group3, /jail|prison|sentenced|arrested/i],
		['job-hunt', @group5, /interview\w{0,2}|(get\w{0,4}\sa\s|look\w{0,3}\sfor\sa\s|offer\w{2,3}\sa\s|land\w{0,3}\s(my\sfirst\s|a\s)|dream\s|new\s)job|job\soffers?/i],
		['landlord', @group2, /land(\s|-)(lord|holder|ownder)|laird|proprietor|slumlord/i],
		['loan', @group3, /loan\w{0,3}|(borrow\w{0,3}|lend\w{0,3}|owes\sme)\s(money|cash)|my\smoney|funding/i],
		['loneliness', @group4, /isolated|so\salone|((no|\bany)|mak\w{1,3})\sfriends|(feel\s)?lonel(y|iness)/i],
		['love', @group2, /love(\swith?)\s(him|her)|(s?he)(\sis\s|'\s)the\sone|in\slove|hav\w{1,3}\sfeelings|friendzoned?|i\slike\s(him|her)|crush\b/i],
		['low cash', @group3, /short\son\s|\bbills|\brent\b|(no|without|zero)\s(cash|money)|broke(?!\sup)|ends\smeet/i],
		['marriage', @group2, /marr\w{1,4}/i],
		['mental disorders', @group1, /\bmental\w{0,2}\b|schizophreni(c|a)|asperger|autis\w{1,3}|attention\sdeficit\s(hyperactivity\s)?(disorder)?|adhd|agoraphobia|dementia|I('m|\sam)\slosing\s(it|my\s(mind|head))/i],
		['missing out', @group2, /miss\w{0,3}\sout/i],
		['motivation', @group4, /motivat\w{0,3}/i],
		['moving out', @group3, /mov\w{1,3}\s(back|out|(in)?to)|(liv\w{1,3}|leav\w{0,3})\s(with\s(me|us)|(in\s)?(my|our)\s(house|apartment|country))/i],
		['narcissism', @group2, /narcissis\w{1,3}|ego\w{0,7}|complain\w{0,3}/i],
		['neglect', @group3, /ne@group3, gl\w{0,5}|disregard\w{0,3}|omiss\w{0,3}/i],
		['neighborhood', @group2, /neighbor\w{0,4}|i'?m?\sliv\w{1,3}\snext/i],
		['nostalgia', @group4, /nostalg\w{1,2}|(wan((t\sto)|na)\sgo\sback\sto\sthe|miss\sthe)\s(past|old\sdays)/i],
		['outfit', @group2, /out-?fit|(what\sto|how\sshould\si)\sdress|what\s(should\si|to)\swear/i],
		['overweight', @group1, /over(\s|-)weight|fat\b|obes\w{1,3}|chubby/i],
		['parents-in-law', @group2, /(mother|father|parents|sister|brother)(-|\s)in(-|\s)law|(girl|boy)friend's\s((father|dad)|(mo(m|ther)|(sister)|(brother)))/i],
		['pet', @group2, /(our|my)\s(new\s)?(cat|dog|fish)|animal/i],
		['pregnancy', @group1, /pregnan\w{1,2}|in\slabor|having\s(a\s)?(bab\w{1,3}|twins)|first\s(baby|child|son|daughter)/i],
		['productivity', @group5, /productiv\w{1,3}/i],
		['racism', @group3, /racis\w{1,3}|race|skin\s(color|tone)|(color|tone)\sof\s(my|her|his)\sskin/i],
		['remote-relationship', @group2, /(long\sdistance|remote)\srelationship/i],
		['reputation', @group2, /reputation|status|(see\w{0,3}\s|think\w{0,3}\s(of\s)?)me\sas|\btag\w{0,4}|\bembarrass\w{2,4}|\ba?sham\w{1,3}/i],
		['resignation', @group5, /resign\w{0,5}|quit\w{0,4}\s(the|my)\sjob|ren(ounces?|unciation)/i],
		['scam', @group3, /scam\w{0,3}/i],
		['school', @group5, /(3, high)?(middle)?(home)?\s?-?school(work)?/i],
		['self-discovery', @group4, /i\sdon't\sknow\swho\si\sam|belong\w{0,3}\s(some|any)where|(((lack|ausence|absence)\sof\s)|(no)\s)personality|empty\s(shell|inside)/i],
		['self-esteem', @group4, /self(\s|-)esteem|worthless/i],
		['sensitive', @group4, /sensitive/i],
		['sex', @group2, /(genitalia|dick|penis|cock|pussy|vagina|clitoris|hymen)\s?(hygiene|smells)?|smells\sdownstairs|(anal)?\s?sex(ual)?\s?(addict\w{0,3})?|mak{1,3}\sout|touch\w{0,3}\s(him|her|my)self|turn\w{0,3}\s(me\s|him\s|her\s)?on|dominant\w{0,3}\spartner/i],
		['sexual assault', @group3, /\brap(ed?|ist|ing)|(un-?)?consensual\s(pic\w{0,5}|photos?)|soaked\spanties|sexual\sassault\w{0,3}|\bmolest\w{0,3}/i],
		['sexual orientation', @group2, /(stuck\sin|com\w{1,3}\sout\of)\sthe\scloset|gay|(homo|bi)sexual|(my|his|her)\ssexuality/i],
		['slander', @group3, /defamation|\bslander\b|\blibel\b|\bli(es?|ying)|gossip\{0,3}|false\w{0,2}\s\baccus\w{2,6}/i],
		['sleep', @group1, /(can't|cannot|trouble)\ssleep\w{0,3}(-?(walk\w{1,3})?)|insomnia|^(?!his|hers?|theirs?)dream\w{0,3}|^(?!worse\s)nightmares?/i],
		['social anxiety', @group2, /awkward\ssilence|((add\s(on\s)?to\s(the\s))|((hold\w{0,3}\s(a\s)?)|(maintain\w{0,3}\s(\sa\s)?)))(talk|conversation)|i\sjust\s(sit|stay)\sthere\s(quietly|in\ssilence)|don't\stalk\smuch\sat|\btalk\w{0,3}\s(normally|like\s(a\s)?normal\s(people|person))|((scared|terrified)\sof|thought\sof\smeeting(\swith)?)\s(other\s)?people|talk\w{0,3}\sto\speople|sociable|social(\s|-)anxiety|introvert/i],
		['stalking', @group3, /stalk\w{0,3}|follow\w{0,3}\sme/i],
		['stealing', @group3, /steal\w{0,3}|sto(len|rmed)|(robb|mugg)ed|br[e|o]a?k\w{1,3}\sinto|ransack\w{0,3}/i],
		['stress', @group4, /^(?!di)stress\w{0,3}(?!\srelief)/i],
		['street fight', @group3, /street\s(fight\w{0,3}|brawl\w{0,3})|fight\w{0,3}\son\s(the\s)?streets?/i],
		['student debt', @group5, /students?\sdebts?|\btuitions?\b|pay\w{0,3}\s(for\s)?college/i],
		['studies', @group5, /stud(y|ies)|math(ematics)?|chemistry|\balgebra\b|geo(metry|graphy)|physics|biology|\blearn\w{0,3}/i],
		['suicide', @group4, /(commit\w{0,3}|attempt\w{0,3}|fee?l\w{0,3})?\s?suicid\w{0,3}(\sattempt)?|(kill\w{0,3}|shoo?t\w{0,3}|h[ua]ng\w{0,3})\s\w{2,3}self|((end\s(this|my))|((took|tak\w{1,3})\s(his|her)\s(own)?))\slife/i],
		['surgery', @group1, /surger\w{1,3}|implants|nosejob|rhinoplasty|liposuction|facelift|transplant/i],
		['time off', @group5, /(time|lay|day)(-|\s)off|vacation/i],
		['tiredness', @group1, /tired|lazy|(no|lack\sof)\senergy/i],
		['traffic accident', @group3, /^(?!life\s)insurance|(car|motorcycle)\s(accident|crash)|bumpers?|brakes|head(light|lamp)s?|grille/i],
		['trust', @group2, /trust\w{0,3}/i],
		['underweight', @group1, /under(\s|-)weight|anorex\w{0,3}|\bthin\b|skinny/i],
		['unkissed', @group2, /unkissed/i],
		['virginity', @group2, /virgin\w{0,3}/i],
		['wedding', @group2, /wedding/i],
		['work environment', @group5, /(co)?-?\s?workers?|work(-|\s)?(friend)|friend\sat\swork|manager|boss\b|shift\b|(\bhr\b)?human\s?-?resources|employe(e|r)|intern(ship)?\b/i],
		]

	def self.scan(text)
		text = text.gsub(/[()]/, "")
		key_words = []
		string_matches = []
		KEYWORDS.each do |key|
			if key[2].match?(text)
				key_words << key[0]
				string_matches << key[2].match(text)
			end

		end
			
		print "suggest keywords = #{key_words} \n\n"
		print "parts of the text matched for each keyword, in order: \n \n"
		string_matches.each do |key|
			puts key
		end
		print "\n"
	end
end